#include <mpi.h>

void jacobi_iteration (int my_rank, int size, int n_i,
		       double* rhs, double* x_k1, double* x_k)
{
  MPI_Status status;
  int i;

  for (i=1; i<=n_i; i++)
    x_k[i] = 0.5*(rhs[i]+x_k1[i-1]+x_k1[i+1]);

  if (my_rank>0) {
    /* receive from left neighbor */
    MPI_Recv (&(x_k[0]),1,MPI_DOUBLE,
	      my_rank-1,501,MPI_COMM_WORLD,&status);
    /* send left neighbor */
    MPI_Send (&(x_k[1]),1,MPI_DOUBLE,
	      my_rank-1,502,MPI_COMM_WORLD);
  }

  if (my_rank<size-1) {
    /* send to right neighbor */
    MPI_Send (&(x_k[n_i]),1,MPI_DOUBLE,
	      my_rank+1,501,MPI_COMM_WORLD);
    /* receive from right neighbor */
    MPI_Recv (&(x_k[n_i+1]),1,MPI_DOUBLE,
	      my_rank+1,502,MPI_COMM_WORLD,&status);
  }
}
