#include <stdio.h>
#include <mpi.h>
#include <malloc.h>

int main (int nargs, char** args)
{
  int size, my_rank, i, a, sum, *array;
  MPI_Init (&nargs, &args);
  MPI_Comm_size (MPI_COMM_WORLD, &size);
  MPI_Comm_rank (MPI_COMM_WORLD, &my_rank);

  srand (7654321*(my_rank+1));
  a = rand()%100;
  printf("<%02d> a=%d\n",my_rank,a);
  fflush (stdout);

  if (my_rank==0)
    array = (int*) malloc(size*sizeof(int));

  MPI_Gather (&a, 1, MPI_INT, array, 1, MPI_INT,
	      0, MPI_COMM_WORLD);

  if (my_rank==0) {
    sum = a;
    for (i=1; i<size; i++)
      sum += array[i];
    printf("<%02d> sum=%d\n",my_rank,sum);
    free (array);
  }

  MPI_Finalize ();
  return 0;
}   
